;//**   File: gstrtodouble.asm
;//**
;//**   Created by GODlike (www.ancientritual.tk)

.686
.model flat
option casemap: none
		
.code


;=============================================
;   double stdcall gStrToDouble (char* str)
;=============================================
gStrToDouble equ _gStrToDouble@4
gStrToDouble proc
	;/----------------------------------------------------------------------------------------------------------------------\
	;| Classic convertion function.                                                                                         |
	;| Example gStrToDouble("123.456") returns the double 123.456.                                                          |
	;| Acceptable strings "123.456" or "-123.12e+134" or "1.212E-1".                                                        |
	;| On Error: If incorect char in the string or a wrong string format it returns 0.0.                                    |
	;| Warning!! On "[+-]x.xxxxxxE+xxx" format the proc doesnt checks for unnormalized mantissa (11.122+10 is unnormalized) |
	;\----------------------------------------------------------------------------------------------------------------------/
	push edx                         ;the dh is the mantissa sign and the dl is the exponent sign
	push esi                         ;the pointer to the str
	push ebx                         ;the mantissa
	push ecx                         ;the exponent
	
	cld
	
	mov esi, dword ptr [esp+14h]     ;get the str 
	xor ebx, ebx
	xor edx, edx
	xor eax, eax
	xor ecx, ecx
	
	;---------------------
	;get the mantissa sign
	;---------------------
	lodsb
	.if al>='0' && al<='9'
		jmp @0
	.endif
	
	.if	al=='-'
		or dh, 0FFh
	.elseif al!='+'
		jmp error
	.endif
	
	;-------------------------------
	;loop until '.'. Builds mantissa
	;-------------------------------
	@@:
	lodsb
	@0:
	.if al>='0' && al<='9'
		sub al, '0'
		imul ebx, 0Ah
		add ebx, eax
		jmp @B
	.elseif al==0
		jmp builddouble
	.elseif al!='.'
		jmp error
	.endif

	;-------------------------------------------------------------------------------
	;loop until find the 'e' or 'E' or '\0'. Builds rest of the mantissa and the exp
	;-------------------------------------------------------------------------------
	@@:
	lodsb
	.if al>='0' && al<='9'
		sub al, '0'
		imul ebx, 0Ah
		add ebx, eax
		dec ecx
		jmp @B
	.elseif al==00h
		jmp builddouble
	.elseif al!='e' && al!='E'
		jmp error
	.endif
	
	;-----------------------------------------------------
	;check for exponent sign in "[+-]x.xxxxxxE+xxx" format
	;-----------------------------------------------------
	lodsb
	.if al=='-'
		or dl, 0FFh            ;exponentSign = 1;
	.elseif al!='+'
		jmp error
	.endif
	
	;----------------------------------------------
	;get the exponent in "[+-]x.xxxxxxE+xxx" format
	;----------------------------------------------
	push ecx
	xor ecx, ecx
	@@:
	lodsb
	.if al>='0' && al<='9'
		sub al, '0'
		imul ecx, 0Ah
		add ecx, eax
		jmp @B
	.elseif al!=00h
		jmp error
	.endif

	pop eax
	
	test dl, dl             ;check if exponentSign is '+'
	je @F
		neg ecx
	@@:
	
	add ecx, eax
	
	;------------------------------------------------------------------------------
	;with the help of final vals of mantissa, exponent and manSign build the double
	;------------------------------------------------------------------------------
	builddouble:
	
	test dh, dh              ;if mantissaSign == '-' then neg mantissa
	je @F
		neg ebx
	@@:
	
	push ebx
	fild dword ptr [esp]     ;push the mantissa to the regstack
	
	push ecx
	fild  dword ptr [esp]    ;push the exponent to the regstack
	
	fldl2t                  
	fmul                    
      
	fld   st(0)           
	frndint                 
	fsub  st(1), st        
	fxch                    

	f2xm1                  
	fld1
	fadd                    

	fscale          
	fstp  st(1)

	fmulp st(1), st(0)
	add esp, 08h
	
	jmp noerror

	;-----------------------
	;on any error return 0.0
	;-----------------------
	error:
	fldz	
	
	noerror:
	pop ecx
	pop ebx
	pop esi
	pop edx
	ret 04h
gStrToDouble endp


end